#
# logfunc.pl - supply a function to 
#              log the given line to the given log file with the given level
#
# thomas@apestaart.org
# version 0.2
# last changed : 28/06/2001
#
# level guideline :
# I1 : major info/actions of main systems (start/stop of main package)
# I2 : minor info of ...
# I3 : major info/actions of second-level systems (start/stop)
# I4 : minor info/actions of second-level systems (start/stop)
# E1 : major errors of main systems (critical) 
# E2 : minor errors of main systems (non-critical) 
# E3 : major errors of second-level systems (critical for that package) 
# E4 : minor errors of second-levelsystems (non-critical) 

# please make sure these vars are defined in the main program :
# $LOGFILE : file to log to
# $PROGRAM : name of the current program

use vars qw($LOGFILE $PROGRAM);
use Encode;

sub logger
{
  $level = shift;
  $line = shift;

  open LOG, ">>$LOGFILE" or print "Cannot open log $LOGFILE : $! !\n";
  print LOG scalar localtime ();
  # we need to encode with utf8; the string $line is ok, but
  # printing it prints it wrong, so encode
  print LOG encode_utf8 (" ($level) $$\t$PROGRAM\t$line\n");
  close LOG;
  return 0;
}
1; # you need this so as to not get an error
