------------------------------------------------------------------
-- Postgres queries for dad database
------------------------------------------------------------------

BEGIN;




--
-- Sequences for table ALBUM
--

CREATE SEQUENCE album_album_id_seq;

--
-- Table structure for table `album`
--

CREATE TABLE album (
  album_id INT8 DEFAULT nextval('album_album_id_seq'),
  title char(100) NOT NULL DEFAULT '',
  PRIMARY KEY  (album_id)
);
-- --------------------------------------------------------

--
-- Table structure for table `albumxartist`
--



--
-- Sequences for table ALBUMXARTIST
--

CREATE SEQUENCE albumxartist_axu_id_seq;

CREATE TABLE albumxartist (
  axu_id INT8 DEFAULT nextval('albumxartist_axu_id_seq'),
  artist_id INT8 NOT NULL DEFAULT '0',
  album_id INT8 NOT NULL DEFAULT '0',
  PRIMARY KEY  (axu_id)
);
-- --------------------------------------------------------

--
-- Table structure for table `artist`
--



--
-- Sequences for table ARTIST
--

CREATE SEQUENCE artist_artist_id_seq;

CREATE TABLE artist (
  artist_id INT8 DEFAULT nextval('artist_artist_id_seq'),
  artistname varchar(255) NOT NULL DEFAULT '',
  first_letter_id INT8 NOT NULL DEFAULT '0',
  PRIMARY KEY  (artist_id)
);
-- --------------------------------------------------------

--
-- Table structure for table `asso`
--

CREATE TABLE asso (
  artist_id INT8 NOT NULL DEFAULT '0',
  user_id INT8 NOT NULL DEFAULT '0',
  parent INT8 NOT NULL DEFAULT '0'
);
-- --------------------------------------------------------

--
-- Table structure for table `asso_song`
--

CREATE TABLE asso_song (
  audio_id INT8 NOT NULL DEFAULT '0',
  user_id INT8 NOT NULL DEFAULT '0',
  parent INT8 NOT NULL DEFAULT '0'
);
-- --------------------------------------------------------

--
-- Table structure for table `audio`
--



--
-- Sequences for table AUDIO
--

CREATE SEQUENCE audio_audio_id_seq;

CREATE TABLE audio (
  audio_id INT8 DEFAULT nextval('audio_audio_id_seq'),
  audiofile_id INT8 NOT NULL DEFAULT '0',
  audio_type_id INT2 NOT NULL DEFAULT '0',
  client_id INT2 NOT NULL DEFAULT '0',
  user_last INT8 NOT NULL DEFAULT '0',
  title varchar(255) NOT NULL DEFAULT '',
  album_id INT8 NOT NULL DEFAULT '0',
  track INT2 NOT NULL DEFAULT '0',
  checked INT2 NOT NULL DEFAULT '0',
  PRIMARY KEY  (audio_id)
);
-- --------------------------------------------------------

--
-- Table structure for table `audiofile`
--



--
-- Sequences for table AUDIOFILE
--

CREATE SEQUENCE audiofile_audiofile_id_seq;

CREATE TABLE audiofile (
  audiofile_id INT8 DEFAULT nextval('audiofile_audiofile_id_seq'),
  audiofile_type_id INT2 NOT NULL DEFAULT '0',
  path_id INT8 NOT NULL DEFAULT '0',
  filename char(255) NOT NULL DEFAULT '',
  filesize char(12) NOT NULL DEFAULT '',
  checksum char(255) NOT NULL DEFAULT '0',
  length float NOT NULL DEFAULT '0',
  mix_in float NOT NULL DEFAULT '0',
  mix_out float NOT NULL DEFAULT '0',
  rms INT8 NOT NULL DEFAULT '0',
  intro float NOT NULL DEFAULT '0',
  outro float NOT NULL DEFAULT '0',
  user_in INT8 NOT NULL DEFAULT '0',
  PRIMARY KEY  (audiofile_id)
);
-- --------------------------------------------------------

--
-- Table structure for table `audiofiletype`
--



--
-- Sequences for table AUDIOFILETYPE
--

CREATE SEQUENCE audiofiletype_audiofile_type;

CREATE TABLE audiofiletype (
  audiofile_type_id INT2 DEFAULT nextval('audiofiletype_audiofile_type'),
  filetype char(100) NOT NULL DEFAULT '',
  PRIMARY KEY  (audiofile_type_id)
);
-- --------------------------------------------------------


INSERT INTO audiofiletype VALUES (1,'mp3');  
INSERT INTO audiofiletype VALUES (2,'ogg');  

--
-- Table structure for table `audiotype`
--



--
-- Sequences for table AUDIOTYPE
--

CREATE SEQUENCE audiotype_audio_type_id_seq;

CREATE TABLE audiotype (
  audio_type_id INT2 DEFAULT nextval('audiotype_audio_type_id_seq'),
  audiotype char(100) NOT NULL DEFAULT '',
  PRIMARY KEY  (audio_type_id)
);
-- --------------------------------------------------------

--
-- Table structure for table `audioxartist`
--



--
-- Sequences for table AUDIOXARTIST
--

CREATE SEQUENCE audioxartist_axu_id_seq;

CREATE TABLE audioxartist (
  axu_id INT8 DEFAULT nextval('audioxartist_axu_id_seq'),
  artist_id INT8 NOT NULL DEFAULT '0',
  audio_id INT8 NOT NULL DEFAULT '0',
  PRIMARY KEY  (axu_id)
);
-- --------------------------------------------------------

--
-- Table structure for table `category`
--



--
-- Sequences for table CATEGORY
--

CREATE SEQUENCE category_cat_id_seq;

CREATE TABLE category (
  cat_id INT8 DEFAULT nextval('category_cat_id_seq'),
  description varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY  (cat_id)
);
-- --------------------------------------------------------

--
-- Table structure for table `client`
--



--
-- Sequences for table CLIENT
--

CREATE SEQUENCE client_client_id_seq;

CREATE TABLE client (
  client_id INT8 DEFAULT nextval('client_client_id_seq'),
  clientname varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY  (client_id)
);
-- --------------------------------------------------------

--
-- Table structure for table `firstletter`
--



--
-- Sequences for table FIRSTLETTER
--

CREATE SEQUENCE firstletter_first_letter_id_;

CREATE TABLE firstletter (
  first_letter_id INT8 DEFAULT nextval('firstletter_first_letter_id_'),
  letter char(1) NOT NULL DEFAULT '',
  PRIMARY KEY  (first_letter_id)
);
-- --------------------------------------------------------

--
-- Table structure for table `last_playlist`
--

CREATE TABLE last_playlist (
  audio_id INT8 NOT NULL DEFAULT '0',
  artist_id INT8 NOT NULL DEFAULT '0',
  user_id INT8 NOT NULL DEFAULT '0',
  lastorder INT8 NOT NULL DEFAULT '0'
);
-- --------------------------------------------------------

--
-- Table structure for table `path`
--



--
-- Sequences for table PATHS
--

CREATE SEQUENCE paths_path_id_seq;

CREATE TABLE paths (
  path_id INT8 DEFAULT nextval('paths_path_id_seq'),
  path varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY  (path_id)
);
-- --------------------------------------------------------

--
-- Table structure for table `save_playlist`
--

CREATE TABLE save_playlist (
  audio_id INT8 NOT NULL DEFAULT '0',
  artist_id INT8 NOT NULL DEFAULT '0',
  user_id INT8 NOT NULL DEFAULT '0',
  saveorder INT8 NOT NULL DEFAULT '0',
  playlistname varchar(255) NOT NULL DEFAULT '',
  playlist_id INT8 NOT NULL DEFAULT '0'
);
-- --------------------------------------------------------

--
-- Table structure for table `score`
--

CREATE TABLE score (
  audio_id INT8 NOT NULL DEFAULT '0',
  user_id INT8 NOT NULL DEFAULT '0',
  cat_id INT8 NOT NULL DEFAULT '0',
  rate float NOT NULL DEFAULT '0'
);
-- --------------------------------------------------------

--
-- Table structure for table `temp_playlist`
--

CREATE TABLE temp_playlist (
  audio_id INT8 NOT NULL DEFAULT '0',
  artist_id INT8 NOT NULL DEFAULT '0',
  user_id INT8 NOT NULL DEFAULT '0',
  temporder INT8 NOT NULL DEFAULT '0'
);
-- --------------------------------------------------------

--
-- Table structure for table `unrated`
--

CREATE TABLE unrated (
  audio_id INT8 NOT NULL DEFAULT '0',
  cat_id INT8 NOT NULL DEFAULT '0',
  user_id INT8 NOT NULL DEFAULT '0'
);
-- --------------------------------------------------------

--
-- Table structure for table `user`
--



--
-- Sequences for table USERS
--

CREATE SEQUENCE users_user_id_seq;

CREATE TABLE users (
  user_id INT8 DEFAULT nextval('users_user_id_seq'),
  username varchar(20) NOT NULL DEFAULT '',
  password varchar(30) NOT NULL DEFAULT '',
  first_name varchar(50) NOT NULL DEFAULT '',
  last_name varchar(50) NOT NULL DEFAULT '',
  level INT2 NOT NULL DEFAULT '0',
  mount varchar(50) NOT NULL DEFAULT '0',
  system INT2 NOT NULL DEFAULT '0',
  PRIMARY KEY  (user_id)
);

--
-- Indexes for table LAST_PLAYLIST
--

CREATE UNIQUE INDEX audio_id_last_playlist_index ON last_playlist (audio_id,user_id);

--
-- Indexes for table FIRSTLETTER
--

CREATE UNIQUE INDEX first_letter_id_firstletter_index ON firstletter (first_letter_id);

--
-- Indexes for table CATEGORY
--

CREATE UNIQUE INDEX cat_id_category_index ON category (cat_id);

--
-- Indexes for table AUDIOFILETYPE
--

CREATE UNIQUE INDEX audiofile_type_id_audiofiletype_index ON audiofiletype (audiofile_type_id);

--
-- Indexes for table ALBUM
--

CREATE UNIQUE INDEX album_id_album_index ON album (album_id);

--
-- Indexes for table PATHS
--

CREATE UNIQUE INDEX path_id_paths_index ON paths (path_id);

--
-- Indexes for table CLIENT
--

CREATE UNIQUE INDEX client_id_client_index ON client (client_id);

--
-- Indexes for table SAVE_PLAYLIST
--

CREATE UNIQUE INDEX audio_id_save_playlist_index ON save_playlist (audio_id,user_id,playlist_id);

--
-- Indexes for table AUDIO
--

CREATE UNIQUE INDEX audio_id_audio_index ON audio (audio_id);

--
-- Indexes for table ARTIST
--

CREATE UNIQUE INDEX artist_id_artist_index ON artist (artist_id);

--
-- Indexes for table AUDIOXARTIST
--

CREATE UNIQUE INDEX axu_id_audioxartist_index ON audioxartist (axu_id);

--
-- Indexes for table AUDIOFILE
--

CREATE UNIQUE INDEX audiofile_id_audiofile_index ON audiofile (audiofile_id);

--
-- Indexes for table USERS
--

CREATE UNIQUE INDEX user_id_users_index ON users (user_id);

--
-- Indexes for table AUDIOTYPE
--

CREATE UNIQUE INDEX audio_type_id_audiotype_index ON audiotype (audio_type_id);

--
-- Indexes for table TEMP_PLAYLIST
--

CREATE UNIQUE INDEX audio_id_temp_playlist_index ON temp_playlist (user_id,audio_id);

--
-- Indexes for table ALBUMXARTIST
--

CREATE UNIQUE INDEX axu_id_albumxartist_index ON albumxartist (axu_id);

--
-- Sequences for table FIRSTLETTER
--

SELECT SETVAL('firstletter_first_letter_id_',(select case when max(first_letter_id)>0 then max(first_letter_id)+1 else 1 end from firstletter));

--
-- Sequences for table CATEGORY
--

SELECT SETVAL('category_cat_id_seq',(select case when max(cat_id)>0 then max(cat_id)+1 else 1 end from category));

--
-- Sequences for table AUDIOFILETYPE
--

SELECT SETVAL('audiofiletype_audiofile_type',(select case when max(audiofile_type_id)>0 then max(audiofile_type_id)+1 else 1 end from audiofiletype));

--
-- Sequences for table ALBUM
--

SELECT SETVAL('album_album_id_seq',(select case when max(album_id)>0 then max(album_id)+1 else 1 end from album));

--
-- Sequences for table PATHS
--

SELECT SETVAL('paths_path_id_seq',(select case when max(path_id)>0 then max(path_id)+1 else 1 end from paths));

--
-- Sequences for table CLIENT
--

SELECT SETVAL('client_client_id_seq',(select case when max(client_id)>0 then max(client_id)+1 else 1 end from client));

--
-- Sequences for table AUDIO
--

SELECT SETVAL('audio_audio_id_seq',(select case when max(audio_id)>0 then max(audio_id)+1 else 1 end from audio));

--
-- Sequences for table ARTIST
--

SELECT SETVAL('artist_artist_id_seq',(select case when max(artist_id)>0 then max(artist_id)+1 else 1 end from artist));

--
-- Sequences for table AUDIOXARTIST
--

SELECT SETVAL('audioxartist_axu_id_seq',(select case when max(axu_id)>0 then max(axu_id)+1 else 1 end from audioxartist));

--
-- Sequences for table AUDIOFILE
--

SELECT SETVAL('audiofile_audiofile_id_seq',(select case when max(audiofile_id)>0 then max(audiofile_id)+1 else 1 end from audiofile));

--
-- Sequences for table USERS
--

SELECT SETVAL('users_user_id_seq',(select case when max(user_id)>0 then max(user_id)+1 else 1 end from users));

--
-- Sequences for table AUDIOTYPE
--

SELECT SETVAL('audiotype_audio_type_id_seq',(select case when max(audio_type_id)>0 then max(audio_type_id)+1 else 1 end from audiotype));

--
-- Sequences for table ALBUMXARTIST
--

SELECT SETVAL('albumxartist_axu_id_seq',(select case when max(axu_id)>0 then max(axu_id)+1 else 1 end from albumxartist));

COMMIT;
