<?php
/* 
 * vi:si:et:sw=4:sts=4:ts=4
 *
 * DAD - Digital Audio Database
 *
 * DAD_Audiofile.php: class for objects from audiofile table
 *
 *  Copyright (C) 2004 Thomas Vander Stichele
 *  Copyright (C) 2004 Kristof De Jaegher
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Street #330, Boston, MA 02111-1307, USA.
 *
 */

require_once "DAD/object.php";

class DAD_audiofile extends DAD_object
{
    /**
     * DAD_audiofile constructor.
     *
     * @access public
     */
    function DAD_audiofile($id)
    {
        if ($id <= 0)
            DAD::raiseError(DAD_ERROR, "DAD_audiofile: invalid id '$id'");

        $this->DAD_object("audiofile", "audiofile_id", $id);
    }
    
    /**
     * Get the relative DAD path where this audiofile lives.
     *
     * @return path to audiofile.
     */
    function getPath()
    {
        global $daddb;
        $query = "SELECT path FROM paths WHERE path_id=" . $this->row->path_id;
        $rows = $daddb->all_rows($query);
        $results = count($rows);
        if ($results != 1)
            DAD::raiseError(DAD_ERROR,
                "DAD_audiofile: $results results for query $query");
        return stripslashes($rows[0]->path);
    }
    /**
     * Get the file type from the audiofiletype table for this audiofile.
     *
     * @return file type of audiofile.
     */
    function getFileType()
    {
        global $daddb;
        $query  = "SELECT filetype FROM audiofiletype ";
        $query .= "WHERE audiofile_type_id=" . $this->row->audiofile_type_id;
        $rows = $daddb->all_rows($query);
        $results = count($rows);
        if ($results != 1)
            DAD::raiseError(DAD_ERROR,
                "DAD_audiofile: $results results for query $query");
        return stripslashes($rows[0]->filetype);
    }


}
?>
