<?php
/* 
 * vi:si:et:sw=4:sts=4:ts=4
 *
 * DAD - Digital Audio Database
 *
 * DAD_object.php: base class for objects from a DAD database table
 *
 *  Copyright (C) 2004 Thomas Vander Stichele
 *  Copyright (C) 2004 Kristof De Jaegher
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Street #330, Boston, MA 02111-1307, USA.
 *
 */

require_once "DAD.php";

/* Create a DAD object and keep it as a global, simulating
 * a class-static variable.
 * Since this file is require_once'd, it will only be created once during
 * an HTTP request.
 * See http://www.webkreator.com/php/techniques/php-static-class-variables.html
 */
$GLOBALS['_transient']['static']['DAD_object']->dad = new DAD();
                                                                                
class DAD_object
{
    var $id;
    var $table;
    var $row;
    var $db;

    /**
     * DAD_object constructor.
     *
     * @access public
     */
    function DAD_object($table, $id_row_name, $id)
    {
        $this->dad = & $GLOBALS['_transient']['static']['DAD_object']->dad;
        /* FIXME: we need to abstract away $daddb too */
        global $daddb;

        if (!$table) {
            return PEAR::raiseError(null, null,
                null, null, null, 'PEAR_Error', true);
        }
        if (!$id) {
            return PEAR::raiseError(null, null,
                null, null, null, 'PEAR_Error', true);
        }
        $this->db = $daddb;
        $this->table = $table;
        $this->id = $id;

        $query = "SELECT * FROM $table WHERE $id_row_name = $id";
        if (! $daddb->query ($query)) {
            DAD::raiseError(DAD_ERROR_ID_NOT_FOUND, $query);
        }
        $this->row = $daddb->row();
    }
}
// }}}

?>
