<?php
/* 
 * vi:si:et:sw=4:sts=4:ts=4
 *
 * DAD - Digital Audio Database
 *
 * browse_songdetail.inc.php: detailed view of an audio.
 *
 *  Copyright (C) 2004 Thomas Vander Stichele
 *  Copyright (C) 2004 Kristof De Jaegher
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Street #330, Boston, MA 02111-1307, USA.
 *
 */

/* the audio_id to browse is passed through GET */

/* FIXME: rename to browse_viewaudio.inc.php to be in line with others */

require_once 'DAD/album.php';
require_once 'DAD/audio.php';
require_once 'DAD/audiofile.php';
require_once 'DAD/user.php';

$audio_id = $_GET['audio_id'];
$audio = new DAD_audio($audio_id);
$audiofile = new DAD_audiofile($audio->row->audiofile_id);
$album_id = $audio->row->album_id;

global $level, $dadid;
?>
<TABLE border=0 cellspacing=0 cellpadding=0 class="menu" width="100%">
  <TR>
    <TD class="menu"><IMG src="images/spacer.gif" width=1 height=20></TD>
    <TD nowrap class="menu">
      <B>Audio details for
<?php
echo "'";
echo $audio->getTitle();
echo "' by ";
echo join($audio->getArtistLinks(), " & ");
?>
</B>
    </TD>
  </TR>
  <TR>
    <TD class="divide" colspan=2>
      <IMG src="images/spacer.gif" width=1 height=1>
    </TD>
  </TR>
</TABLE>
<TABLE cellspacing=2 cellpadding=2 border=0>
  <TR>
    <TD valign=top> 
      <!-- general info table -->
      <TABLE cellspacing=3 cellpadding=3 border=0 class="searchtable">
        <TR>
          <TD class=menu>
            <B>General Info</B>
          </TD>
          <TD colspan=2 align="right">
<?php
echo $audio->getPlayLink($dadid, 1, "Stream audio") . "\n";
echo $audio->getPlayLink($dadid, 2, "Play audio locally") . "\n";
?>
          </TD>
        </TR>
<?php
echo "<TR><TD bgcolor=#CCCCCC>Artist</TD>";
echo "<TD colspan=2>";
echo join($audio->getArtistLinks(), "<BR/>\n");
echo "<BR/>\n";
echo "</TD></TR>\n";

echo "<TR>";
echo "<TD bgcolor=#CCCCCC>Title</TD>";
echo "<TD colspan=2>" . $audio->getTitle() . "</TD>";
echo "</TR>\n";

if ($album_id) {
    $album = new DAD_album($album_id);
    echo "<TR>";
    echo "<TD bgcolor=#CCCCCC>Album</TD>";
    echo "<TD>" . $album->getLink() . "</TD>";
    echo "<TD>(" . $audio->row->track . ")</TD>";
    echo "</TR>\n";
}

echo "<TR>";
echo "<TD bgcolor=#CCCCCC>Type</TD>";
echo "<TD colspan=2>" . $audio->getType()."</TD>";
echo "</TR>\n";

$user = new DAD_user ($audiofile->row->user_in);
echo "<TR>";
echo "<TD bgcolor=#CCCCCC>Put in by</TD>";
echo "<TD colspan=2>" . $user->getName() . "</TD>";
echo "</TR>\n";

$user = new DAD_user ($audio->row->user_last);
echo "<TR>";
echo "<TD bgcolor=#CCCCCC>Last change by</TD>";
echo "<TD colspan=2>" . $user->getName() . "</TD>";
echo "</TR>\n";

/* display an edit button if allowed */
/* FIXME: the page this links to is broken */
/*
if ($level == 1) {
    echo "<TR><TD colspan=2 align=center>";
    echo "<A href=browse.php?dad=editsong&audio_id=$audio_id&";
    echo "album_id=$album_id>";
    echo "<IMG src=images/edit.gif title=Edit alt=Edit border=0></A>\n";
    echo "</TD>";
    echo "</TR>\n";
}
*/
?>
      </TABLE>
    </TD>
    <TD valign=top>
      <!-- file info table -->
      <TABLE cellspacing=3 cellpadding=3 border=0 class="searchtable">
        <TR>
          <TD class=menu colspan=2>
            <B>File info</B>
          </TD>
        </TR>
<?php
echo "<TR><TD bgcolor=#CCCCCC>Filename</TD>";
echo "<TD>" . stripslashes($audiofile->row->filename) . "</TD></TR>\n";
echo "<TR><TD bgcolor=#CCCCCC>Filesize</TD>";
echo "<TD>" . $audiofile->row->filesize . " KB</TD></TR>\n";
echo "<TR><TD bgcolor=#CCCCCC>Filetype</TD>";
echo "<TD>" . $audiofile->getFileType() . "</TD></TR>\n";
echo "<TR><TD bgcolor=#CCCCCC>Directory</TD>";
echo "<TD>" . $audiofile->getPath() . "</TD></TR>\n";
echo "<TR><TD bgcolor=#CCCCCC>Length</TD>";
echo "<TD>" . $audiofile->row->length . " (";
echo hhmmss($audiofile->row->length);
echo ")</TD></TR>\n";
echo "<TR><TD bgcolor=#CCCCCC>Mix-in point</TD>";
echo "<TD>" . $audiofile->row->mix_in . " (";
echo hhmmss($audiofile->row->mix_in);
echo ")</TD></TR>\n";
echo "<TR><TD bgcolor=#CCCCCC>Mix-out point</TD>";
echo "<TD>" . $audiofile->row->mix_out . " (";
echo hhmmss($audiofile->row->mix_out);
echo ")</TD></TR>\n";
echo "<TR><TD bgcolor=#CCCCCC>Intro</TD>";
echo "<TD>" . $audiofile->row->intro . "</TD></TR>\n";
echo "<TR><TD bgcolor=#CCCCCC>Outro</TD>";
echo "<TD>" . $audiofile->row->outro . "</TD></TR>\n";
echo "<TR><TD bgcolor=#CCCCCC>RMS</TD>";
echo "<TD>" . $audiofile->row->rms . "</TD></TR>\n";

/* display an edit button if allowed */
/* FIXME: the page this links to is broken */
/*
if ($level == 1) {
    echo "<TR>\n<TD colspan=2 align=center>";
    echo "<A href=browse.php?dad=editsong&";
    echo "audio_id=$audio_id&album_id=$album_id>";
    echo "<IMG src=images/edit.gif title=Edit alt=Edit border=0>";
    echo "</A></TD></TR>\n";
}
*/
?>
      </TABLE>
    </TD>
    <TD valign=top>
      <!-- ratings table -->
      <TABLE cellspacing=3 cellpadding=3 border=0 class="searchtable">
        <TR>
          <TD class=menu colspan=2>
            <B>Ratings</B>
          </TD>
        </TR>
<?php

/* FIXME: this needs to be abstracted away as well */
$query = "SELECT cat_id,description FROM category ORDER BY description ASC";
$catrows = $daddb->all_rows($query);

for ($i = 0;$i < count($catrows); $i++) {
    echo "<TR>\n<TD bgcolor=#CCCCCC>";
    echo stripslashes($catrows[$i]->description);
    echo "</TD>";
    echo "<TD>";

    $queryun  = "SELECT audio_id FROM unrated ";
    $queryun .= "WHERE audio_id=$audio_id ";
    $queryun .= "AND cat_id=" . $catrows[$i]->cat_id . " ";
    $queryun .= "AND user_id=$dadid";
    $daddb->query($queryun);
    $rowun = $daddb->row_count();

    $querys  = "SELECT rate FROM score ";
    $querys .= "WHERE audio_id=$audio_id ";
    $querys .= "AND cat_id=" . $catrows[$i]->cat_id . " ";
    $querys .= "AND user_id=$dadid";
    $daddb->query($querys);
    $rows = $daddb->row();

    if (!$rows && !$rowun)
        echo "Not applicable";
    else if (!$rows && $rowun) 
        echo "Unrated";
    else
        echo $rows->rate * 1000;

    echo "</TD></TR>\n";
}

echo "<TR><TD colspan=2 align=center>";
echo "<A href=browse.php?dad=songratings&audio_id=$audio_id";
echo "&album_id=$album_id>";
echo '<IMG src="images/edit.gif" title="Edit" alt="Edit" border=0>';
echo "</A></TD></TR>\n";
?>
      </TABLE>
    </TD>
  </TR>
</TABLE>
