<?php
/* 
 * vi:si:et:sw=4:sts=4:ts=4
 *
 * DAD - Digital Audio Database
 *
 * browse_viewletter.inc.php: browse a given first letter
 *
 *  Copyright (C) 2004 Thomas Vander Stichele
 *  Copyright (C) 2004 Kristof De Jaegher
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Street #330, Boston, MA 02111-1307, USA.
 *
 */
require_once "DAD/artist.php";

/* the letter to browse is passed through GET */

$panesize = 20; /* number of items per pane; FIXME: get from conf */

/* pull in the pane javascript code */
include "lib/pane.js";

$letter = $_GET['letter'];

$query  = "SELECT letter FROM firstletter ";
$query .= "WHERE first_letter_id = '$letter'";
$daddb->query($query);
$row = $daddb->row();
$lettername = stripslashes($row->letter);
?>
<TABLE border=0 cellspacing=0 cellpadding=0 class="menu" width="100%">
  <TR>
    <TD class="menu"><IMG src="images/spacer.gif" width=1 height=20></TD>
    <TD nowrap class="menu" align=right></TD>
    <TD class="menu" width="100%">
      <B>Artists beginning with '<?php echo $lettername;?>'</B>
    </TD>
  </TR>
  <TR>
    <TD class="divide" colspan=3>
      <IMG src=images/spacer.gif width=1 height=1>
    </TD>
  </TR>
</TABLE>
<?php
$query  = "SELECT artist_id,artistname FROM artist ";
$query .= "WHERE first_letter_id=$letter ";
$query .= "ORDER BY artistname ASC";
$rows = $daddb->all_rows($query);
$items = count($rows);

/* construct artist tabs */
echo "\n<!-- artist tabs -->\n";
echo "<TABLE border=0 cellspacing=2 cellpadding=2>\n";
echo "<TR>\n";

for ($i = 0; $i < $items; $i += $panesize) {
    $tab = $i / $panesize + 1; /* no intval needed here */
    $lower = $i + 1;
    $upper = $i + $panesize;
    if ($upper > $items) $upper = $items;

    echo '<TD><DIV id="tab_' . $tab .'" class="tab" ';
    echo 'onClick="showPane(' . $tab . ');" ';
    echo 'onMouseOver="hover(this);" ';
    echo 'onMouseOut="setState(' . $tab . ')">';
    echo "Artists $lower - $upper</DIV></TD>\n";
}
echo "</TR>";
echo "</TABLE>";

/* construct artist panes */
echo "\n<!-- artist panes -->\n";
echo '<TABLE border=0 cellspacing=2 cellpadding=2 width="90%">';
echo "\n";
echo "<TR>\n<TD>\n";
$item = 1; /* going from 1 to items */
foreach ($rows as $row) {
/* if item is a multiple of panesize + 1, it's the first on a new pane */
if ($item % $panesize == 1) {
    $pane = intval ($item / $panesize) + 1;
    echo '<DIV id="pane_' . $pane . '" class="pane">';
    echo "\n";
    echo "<TABLE cellspacing=1 cellpadding=1 border=0>\n";
  }
  /* print the link */
  $artist = new DAD_artist ($row->artist_id);
  echo "<TR>\n<TD>$item)</TD>\n<TD>";
  echo $artist->getLink();
  echo "</TD>\n</TR>\n";
  /* if item is a multiple of panesize, or equal to rows, it's the last */
  if (($item % $panesize == 0) or ($item == $items)) {
    echo "</TABLE>\n";
    echo "</DIV>\n\n";
  }
  ++$item;
}
echo "</TD>\n</TR>\n</TABLE>\n";
?>

