<?php
/* 
 * vi:si:et:sw=4:sts=4:ts=4
 *
 * DAD - Digital Audio Database
 */
class dbdad
{
    var $output_html = TRUE;

    /**
     * Connect to the DAD database.
     *
     * @return bool whether or not connection succeeded.
     */

    function connect($DB_HOST, $DB_USER, $DB_PASS, $DB_NAME,
        $persistent = FALSE)
    {
        @mysql_connect($DB_HOST, $DB_USER, $DB_PASS) or die (header("location: error.php?id=2"));

        $this->connection = @mysql_connect($DB_HOST, $DB_USER, $DB_PASS);

        if (!@mysql_select_db($DB_NAME, $this->connection))
            header("location: error.php?id=3");
        return TRUE;
    }

    /**
     * Perform a query on the DAD database.
     *
     * @param string $query database query to perform
     * @param int $key optional numeric key to store the results under
     *
     * @return bool whether or not the query succeeded.
     */
    function query($query, $key = 0, $debug = FALSE)
    {
        $this->last_query = $query;

        $this->results[$key] = mysql_query($query, $this->connection);
        if (!$this->results[$key]) {
            return FALSE;
        }
        return TRUE;
    }

    /**
     * Get the next row from a previous lookup.
     *
     * @param int $key numeric key to the result to get the next row from.
     *
     * @return object the database row.
     */
    function row($key = 0)
    {
        if (! $this->results[$key])
            print "ERROR: no result set for key $key";
        return mysql_fetch_object($this->results[$key]);
    }

    /**
     * Get all database rows for given query.
     *
     * @param string $query database query to perform
     *
     * @return array the database rows.
     */
    function all_rows($query)
    {
        /* we generate a unique id so we can repeatedly call row() */
        $result = array();
        $key = uniqid(0);
        if (!$this->query($query, $key)) {
            return null;
        }
        while ($row = $this->row($key)) {
            $result[] = $row;
        }
        return $result;
    }

    /**
     * Get all database rows for given query as a hash indexed on the
     * given key.
     *
     * @param string $query database query to perform
     * @param string $keyname the key name to use as the hash index
     *
     * @return array the database rows.
     */
    function all_rows_keyed($query, $keyname)
    {
        $result = array();

        $key = uniqid(0);
        $this->query ($query, $key);
        while ($row = $this->row ($key)) {
            # row is a mysql object so use methods to get values
            $keyval = $row->$keyname;
            $result[$keyval] = $row;
        }
        return $result;
    }

    /**
     * Get the row count for the last operation.
     * This is the number of affected rows on INSERT/UPDATE/DELETE,
     * or the number of rows in the result set for the last query.
     *
     * @return int the row count.
     */
     function row_count()
     {
        /* which command was used for the last query ? */
        $command = strtoupper(substr($this->last_query, 0, 6));
        if ($command == 'INSERT' ||
            $command == 'UPDATE' ||
            $command == 'DELETE') {
            return  mysql_affected_rows($this->connection);
        } else {
            return mysql_num_rows(max($this->results));
        }
    }

    /**
     * Create a new id in the given table.
     *
     * This is the number of affected rows on INSERT/UPDATE/DELETE,
     * or the number of rows in the result set for the last query.
     *
     * @return mixed the contents of the row inserted, or FALSE.
     */
     /* FIXME: rename this function */
     function last_id($table, $serial_column = 'id')
     {
        $contents = mysql_insert_id($this->connection);
        if ($contents) {
            return $contents;
        } else {
            return FALSE;
        }
    }

    # begin and commit function are empty
    # because mysql doesn't have this as default in compilation !
    function begin()
    {
    }

    function commit()
    {
    }

    /* FIXME: what does this do ? */
    function nextvalue($nextvalue)
    {
        return "''";
    }
}
?>
