<?php

/* 
  System wide DAD-functions
  used in several files and functions
 
  order :  
  - hhmmss (convert seconds to hours:minutes:seconds)
  - userlogged : see if cookie is really an existing user
  - usertempplay : songs in temp/last/saved playlist
  - patch check
  - capitalize: capitalize first letter of each word
  - dad_get_audio_extensions: gets all extensions considered as audio
                              from database
  - dad_error: print error and stop processing
  - dad_new_audio_destination: create and return new path for given audio file
  - dad_get_table: get all table rows indexed by given key
  - header_content_type: output the right header with content type
*/

/*----------------------------------------------------------*/
# function hhmmss (convert seconds to hours:minutes:seconds)
/*----------------------------------------------------------*/

function hhmmss($length){
 $length = round($length);
 $length = number_format($length,0);
 $length = str_replace(",","",$length);
 $hrs = floor($length / 3600);
 $min = $length - $hrs * 3600;
 $min = floor ($min / 60);
 if ($min < 10) $min = "0".$min;
 $sec = $length - $hrs * 3600 - $min * 60;
 if ($sec < 10) $sec = "0".$sec;
 $sec = substr($sec,0,2);
 if ($hrs) echo $hrs.":";
 return $min.":".$sec;
}

/*------------------------------------------------------------------------------*/
# function user check, checks if the existing cookie also is an existing user ..
/*------------------------------------------------------------------------------*/
function userlogged($dadlogin,$dadpass){
global $userrow,$level,$daddb,$dadpass;
  
  $userlog = "select username,password,level from users where username='$dadlogin' AND password='$dadpass'";
  $daddb->query($userlog);
  $userrow = $daddb->row();
  if ($userrow){  
    echo "Logged in as $dadlogin (<a class=menu href=users.php?dad=logout>Logout</a>)";
    $level = $userrow->level;
  } 
  else echo "No user logged in, <a class=menu href=users.php>Login</a></font>";
}

/*----------------------*/
# function usertempplay
/*----------------------*/
function usertempplay(){
global $dadid,$id,$lastsid,$countt,$countl,$daddb;

  $query = "select audio_id from temp_playlist where user_id='$dadid'";
  $daddb->query($query);
  $countt = $daddb->row_count();
  echo " , $countt number(s) in <a class=menu href=playlist.php?dad=playlist&type=temp>temp</a>&nbsp;playlist";

  $query = "select audio_id from last_playlist where user_id='$dadid'";
  $daddb->query($query);
  $countl = $daddb->row_count();
  echo " , $countl number(s) in <a class=menu href=playlist.php?dad=playlist&type=last>last</a>&nbsp;playlist";
  
  $query = "select DISTINCT playlist_id from save_playlist where user_id='$dadid' order by playlist_id DESC";
  $daddb->query($query);
  $count = $daddb->row_count();
  $row = $daddb->row();
  echo " , $count saved <a class=menu href=playlist.php?dad=playlist&type=save&playlist_id=".$row->playlist_id.">playlist(s)</a>";
  $lastsid = $row->playlist_id;
     
  $query = "select playlist_id from save_playlist order by playlist_id DESC limit 1";
  $daddb->query($query);
  $row = $daddb->row();
  $id = $row->playlist_id;
  $id++;
     
} 

/*-------------------*/
# patch check
/*-------------------*/

function versiondb (){
  global $daddb;
  $query = "select version_number from dad_version";
  $daddb->query($query);
  $row = $daddb->row();
  return $row->version_number;
}


function checkpatch(){
  global $daddb,$output;

  $output = "";
  # upgrade to 0.2.1
  function upgradeto_0_2_1()
  {
    global $daddb,$output;
    $query = "alter table audio drop audio_group_id";
    if (!$daddb->query ($query))
    {
      $output .= "<B>There was an error executing query '$query'.</B><br>\n";
    }
    $query = "update dad_version set version_number = '0.2.1'";
    if (!$daddb->query ($query))
    {
      $output .= "<B>There was an error executing query '$query'.</B><br>\n";
    }
    $output .= "DAD is upgraded to version 0.2.1<br><br>";
    $output .= "Changes : <li>Upgraded version number<li>Field dropped in table audio (audio_group_id)<br><br>";
  }

  # upgrade to 0.2.2
  function upgradeto_0_2_2()
  {
    global $daddb,$output;
    $query = "update dad_version set version_number = '0.2.2'";
    if (!$daddb->query ($query))
    {
      $output .= "<B>There was an error executing query '$query'.</B><br>\n";
    }
    $query = "update score set rate = rate / 1000 where rate > 1";
    if (!$daddb->query ($query))
    {
      $output .= "<B>There was an error executing query '$query'.</B><br>\n";
    }

    $output .= "DAD is upgraded to version 0.2.2<br><br>";
    $output .= "Changes : <li>Upgraded version number<li>Scores are now integers between 0 and 1<br><br>";
  }

  # upgrade to 0.2.5
  # alters audiofile table so filename can be 255
  function upgradeto_0_2_5()
  {
    global $daddb, $output;
    $query = "UPDATE dad_version SET version_number = '0.2.5'";
    if (!$daddb->query ($query))
      $output .= "<B>There was an error executing query '$query'.</B><br>\n";

    /* make audiofile.filename bigger */
    $query = "ALTER TABLE audiofile MODIFY filename CHAR(255)";
    if (!$daddb->query ($query))
      $output .= "<B>There was an error executing query '$query'.</B><br>\n";

    /* add indexes on unrated */
    $query  = "ALTER TABLE unrated ";
    $query .= "ADD UNIQUE unrated (audio_id, user_id, cat_id)";
    if (!$daddb->query ($query))
      $output .= "<B>There was an error executing query '$query'.</B><br>\n";

    $query  = "ALTER TABLE last_playlist ";
    $query .= "CHANGE position position int(11) NOT NULL default '0'";
    if (!$daddb->query ($query))
      $output .= "<B>There was an error executing query $query.</B><br>\n";
    $query  = "ALTER TABLE temp_playlist ";
    $query .= "CHANGE position position int(11) NOT NULL default '0'";
    if (!$daddb->query ($query))
      $output .= "<B>There was an error executing query $query.</B><br>\n";
    $query  = "ALTER TABLE save_playlist ";
    $query .= "CHANGE position position int(11) NOT NULL default '0'";
    if (!$daddb->query ($query))
      $output .= "<B>There was an error executing query $query.</B><br>\n";

    $output .= "DAD is upgraded to version 0.2.5<BR/><BR/>";
    $output .= "Changes : \n<UL>";
    $output .= "<LI>Upgraded version number</LI>\n";
    $output .= "<LI>Filenames can now be 255 characters</LI>\n";
    $output .= "<LI>Rating lookups are faster due to indexes added on unrated.</LI>\n";
    $output .= "<LI>All playlist tables now have 'position' as a column.</LI>\n";
    $output .= "</UL>\n";
  }

  if (versiondb() != "0.2.5")
  {
    global $DB_USER, $DB_PASS, $DB_HOST, $DB_NAME;

    $dumpfile = "/tmp/dad.0.2.5.dump.gz";
    $command = "mysqldump -u $DB_USER --password=$DB_PASS -h $DB_HOST $DB_NAME --add-drop-table";
    system ("$command > $dumpfile", $retval);
    if ($retval != 0)
    {
      $output .= "Failed backing up the database to $dumpfile using $command <br>\n";
    }
    else
    {
      $output .= "A backup of the database has been made as $dumpfile<br>\n";
    }
  }

  /* iterate through the versions in order */
  if (versiondb() == "0.2.0") upgradeto_0_2_1();
  if (versiondb() == "0.2.1") upgradeto_0_2_2();
  if (versiondb() == "0.2.4") upgradeto_0_2_5();
  /* set to the new version (when we don't have functions to do so */
  if (versiondb() != "0.2.5")
  {
    $query = "update dad_version set version_number = '0.2.5'";
    $daddb->query($query);
  }

  return $output;
}

/* ----------------- */
# function capitalize
/* ----------------- */
function capitalize($string)
{
  global $newstring;
  $newstring = strtolower($string);
  $newstring = " ".$newstring;
  // set delimiters (space is not needed!
  $delimiters = array("-","(","!");
  $delcount = count($delimiters);
  for ($a=0;$a<$delcount;$a++)
  {
    if (($pos = strpos($newstring,"{$delimiters[$a]}")))
    {  
      //print $pos;
      $pos++;
      if (!empty($newstring{$pos}))
      {
        $newstring = substr_replace($newstring,ucfirst($newstring{$pos}),$pos,1);	
      }
      $pos = false;
    }
  }
  /* get rid of whitespace */
  return trim (ucwords($newstring));
}

/* get an array of all audio extensions from the database
 * FIXME: hardcoded, get from db */
function dad_get_audio_extensions ()
{
  $ret[0] = "ogg";
  $ret[1] = "mp3";
                                                                                
  return $ret;
}

/* print the given error and end processing */
function dad_error ($string)
{
  print "<H3>ERROR: $string</H3>\n";
  exit;
}

/* return the destination location of a new audio file to be imported
 * /opt/dad/new/songs/Aaliyah - Rock The Boat.ogg will end up in
 * /opt/dad/audio/songs/A/AA/Aaliyah - Rock The Boat.ogg
 * also make sure the new directory exists
 */
function dad_new_audio_destination ($old)
{

  /* copied a recursive mkdirs function from the PHP manual and adapted */
  function mkdirs($strPath, $mode = 0700)
  {
    if (is_dir($strPath)) return true;
   
    $pStrPath = dirname($strPath);
    if (!mkdirs($pStrPath, $mode)) return false;
    return mkdir($strPath);
  }

  global $AUDIO_DIR, $NEW_DIR;

  /* split old path in $NEWDIR, some prefix, and the song name */

  /* strip off NEWDIR from the front */
  $pattern = "@^" . $NEW_DIR . "@";
  $relpath = preg_replace ($pattern, "", $old);

  /* split in a prefix path and the filename */
  $filename = basename ($relpath);
  $prefix = dirname ($relpath);

  /* now construct the new location using first two letters of filename */
  /* strip away everything that is not a letter for this */
  $temp = preg_replace ('/[^a-zA-Z]/', '', $filename);
  $first = strtoupper ($temp{0});
  $second = strtoupper ($temp{1});
  $firsttwo = $first.$second;
  $dir = "$AUDIO_DIR/$prefix/$first/$firsttwo";

  /* make sure the dir exists */
  if (! is_dir ($dir))
    if (! mkdirs ($dir))
      return; /* empty string means error occured */
  
  return "$dir/$filename";
}

/* return an array of $key -> table rows */
function dad_get_table ($table, $key)
{
  global $daddb;
                                                                                
  $daddb->begin ();
  $query = "SELECT * FROM $table";
  return $daddb->all_rows_keyed ($query, $key);
}

function header_content_type ()
{
  header ("Content-type: text/html; charset=UTF-8");
}

/* if the global variable DAD_DEBUG is set (through debug=1 in _GET)
 * then print the given message */
function debug ($message)
{
  if (isset ($_GET["debug"]))
    print "DEBUG: $message<BR/>\n";
}
?>
