<?php
  /** 
   * import_default.inc.php:
   * import new single audio files/complete albums from new dir
   * or rescan for albums/audio files in audio dir
   *
   * logic:
   * - for new imports:
   *   - get an array of all the directories in the new tree
   *   - remove all of the dirs with an .m3u and .m3u.new and put these
   *     in a m3u_new array
   *   - remove all of the dirs with an .m3u (but no .m3u.new) and put these
   *     in a m3u array
   *   - remove all of the dirs that contain audio files and put them in
   *     audio array
   *
   * - for rescans:
   *   FIXME
   */

?>
<script language="Javascript">
function setCheckboxes(the_form, do_check, array)
{
    var elts      = document.forms[the_form].elements[array];
    var elts_cnt  = (typeof(elts.length) != 'undefined')
                  ? elts.length
                  : 0;
                
    if (elts_cnt) {
        for (var i = 0; i < elts_cnt; i++) {
            elts[i].checked = do_check;
        } // end for
    } else {
        elts.checked        = do_check;
    } // end if... else
         
    return true;
} // end of the 'setCheckboxes()' function

</script>
<?php
set_time_limit(0);

if (!isset($_GET['type'])) $type = ''; else $type = $_GET['type'];

echo "<table border=0 cellspacing=0 cellpadding=0 class=\"menu\" width=\"100%\">\n";
echo "<tr><td class=\"menu\"><img src=images/spacer.gif width=1 height=20></td>";
echo "<td nowrap class=\"menu\"><b class=menu>Import : </b>&nbsp;";
echo "<a href=import.php?type=new_albums>Scan for albums in 'new' directory</A>";
echo " - ";
echo "<a href=import.php?type=new_files>Scan for audio files in 'new' directory</A>";
echo " - ";
echo "<a href=import.php?type=rescan_albums>Rescan for albums (.m3u) in 'audio' directory</a>";
echo " - ";
echo "<a href=import.php?type=rescan_files>Rescan for audio in 'audio' directory</A>";
echo "</td></tr>\n";   
echo "<tr><td class=\"divide\" colspan=2><img src=images/spacer.gif width=1 height=1></td></tr>\n";
echo "</table>\n";


/********************
 * HELPER FUNCTIONS *
 ********************/

/* a fake php5 function copied from the manual */
function php5_scandir($dirstr) {
    // thomas: add safety check
    if (is_dir ($dirstr) == FALSE) return;
    // php.net/scandir (PHP5)
    // FIXME: add a check if we are allowed to scan this dir
    if (!$fh = opendir($dirstr)) return;
    $files = array();
    while (false !== ($filename = readdir($fh))) {
        array_push($files, $filename);
    }
    closedir($fh);
    return $files;
}

/* get all the directories recursively from this path */
/* call this recursively, we love recursion */
/* removes trailing '/' from path */

function get_directories ($path)
{
  $path = rtrim ($path, "/");
  $ret = array ();
  //print "DEBUG: get_directories: checking $path<BR>\n";
  $entries = php5_scandir ($path);
  if (!$entries) return;

  //print "DEBUG: entries in dir $path:";
  //print_r ($entries);
  foreach ($entries as $i => $entry)
  {
    /* check if the entry is a dir, if not then unset it */
    if (!is_dir ("$path/$entry")) { unset ($entries[$i]); }
    /* check if it's a dir we don't want */
    if ($entry == '.' || $entry == '..') { unset ($entries[$i]); }
  }

  //print "DEBUG: scrubbed entries array: \n";
  //print_r ($entries);
  /* move them to ret, prefixing with path */
  foreach ($entries as $i => $entry)
  {
    $fullpath = "$path/$entry";
    flush ();
    array_push ($ret, $fullpath);
    //print_r (get_directories ($fullpath));
    /* merge in lower-level results */
    $lower = get_directories ($fullpath);
    $ret = array_merge ($ret, $lower);
  }

  //print "DEBUG: for $path we return array";
  //print_r ($ret);
  //print "<BR>\n";
  return $ret;
}
/* check if the given directory contains entries that matches the given regexp
 * return an array of entries that match
 * return nothing if none matched
 */
function dir_get_entries_by_regexp ($dir, $regexp)
{
  $ret = array ();
  $entries = php5_scandir ($dir);
  if (!$entries) return;
  foreach ($entries as $i => $entry)
    if (preg_match ($regexp ,$entry))
      array_push ($ret, $entry);
  return $ret;
}

/* check if the given directory contains entries that matches the given regexp
 * return an array of complete paths for entries that match
 * return nothing if none matched
 */
function dir_get_files_by_regexp ($dir, $regexp)
{
  $ret = array ();
  $entries = dir_get_entries_by_regexp ($dir, $regexp);
  if (!$entries) return;
  foreach ($entries as $i => $entry)
    array_push ($ret, "$dir/$entry");
  return $ret;
}

/* check the given array of directories
 * remove each directory entry that contains a file that matches 
 * the given regexp
 * return an array of dirs matching the regexp
 * $dirs is passed by reference so we can remove sieved entries */
function sieve_by_regexp (&$dirs, $regexp)
{
  if (!$dirs) return;

  $ret = array ();

  foreach ($dirs as $i => $dir)
  {
    if (dir_get_files_by_regexp ($dir, $regexp))
    {
      array_push ($ret, $dir);
      unset ($dirs[$i]);
    }
  }  
  return $ret;
}

/********************
 * IMPORT FUNCTIONS *
 ********************/

/* handle import of new files
 * given array contains directories where supported audio files live
 */

function import_new_files ($dirs_files , $change)
{
  $files = array ();
  $exts = dad_get_audio_extensions ();
  foreach ($dirs_files as $i => $dir)
  {
    foreach ($exts as $j => $ext)
    {
      $regexp = "/\.".$ext."$/";
      $files = array_merge ($files, dir_get_files_by_regexp ($dir, $regexp));
    }
  }

  /* display a checkbox for each of these files */

  $type = "new_audio";
  $change_form  = "";
  $display_form = "";

  $display_form .= "<FORM action=import.php?dad=scan_step1&type=$type method=post name=\"entriesform\">\n";
  foreach ($files as $i => $file)
  {
    $display_form .= "<input type=checkbox name=entries[] value=\"";
    # Do not put caps on next line, otherwhise he won't find the file to import !
    $display_form .= stripslashes ($file)."\" checked>";
    $display_form .= stripslashes ($file)."<br>\n";
    $change_form .= "<input type=text name=file[] value=\"".caps(basename(stripslashes($file)))."\" size=70>";
    $change_form .= "<input type=hidden name=file_orig[] value=\"".basename(stripslashes($file))."\">";
    $change_form .= "<input type=hidden name=path[] value=\"".dirname($file)."\"><br>\n";
  }
  $display_form .= "<br>";
  if ($files) 
  {
    $display_form .= "<a href=import.php?type=$type&checkall=1 onclick=\"setCheckboxes('entriesform', true, 'entries[]'); return false;\">Check All</a> - ";
    $display_form .= "<a href=import.php?type=$type onclick=\"setCheckboxes('entriesform', false, 'entries[]'); return false;\">Uncheck All</a><br><br>";

    $display_form .= "<input type=submit value=\"Import files\">";
    $display_form .= "<input type=button value=\"Change files\" onclick=\"location.href='import.php?type=new_files&change=1'\">\n";
    $display_form .= "</FORM>";

    /* $change triggers display form or edit form */
    if (empty($change)) echo $display_form;
    else
    { 
      echo "<br><b>Change Files</b>\n";
      echo "<FORM action=import.php?dad=change_files method=post>\n";
      echo $change_form; 
      echo "<br><input type=submit value=\"Change files\">\n";
      echo "</FORM>\n";
    }
  }
  else
  {
    global $NEW_DIR;
    echo "Nothing to import under ".$NEW_DIR;
  }
}

/* handle import of new albums
 * first array holds all the dirs with an .m3u.new
 * second array holds all the dirs with only an .m3u
 */

function import_new_albums ($dirs_m3u_new, $dirs_m3u)
{
  global $DEBUG;

  $type = "new_albums";
  echo "<FORM action=import.php?dad=scan_step1&type=$type method=post name=\"entriesform\">\n";

  /* display import stuff for all dirs that have corrected m3u */
  if ($dirs_m3u_new) 
  {
    if ($DEBUG)
    {
      print "<br>\nDEBUG: array of new m3u dirs:\n";
      print_r ($dirs_m3u_new);
      print "<br>\n";
    }
    foreach ($dirs_m3u_new as $i => $dir)
    {
      $files = dir_get_entries_by_regexp ($dir, "/\.m3u\.new$/");
      $m3u_new = $files[0];
      /* warn about leading spaces */
      if (ltrim ($m3u_new) != $m3u_new)
        print "WARNING: '$m3u_new' contains leading whitespace !<BR>\n";
      echo "<input type=checkbox name=entries[] value=\"";
      echo stripslashes ($dir)."\" checked>";
      $href = "import.php?dad=create_m3u_new";
      $href .= "&path=".urlencode (utf8_encode ($dir));
      #$href .= "&m3u=".urlencode (utf8_encode ( (addslashes ($files[0])));
      $href .= "&m3u=".urlencode (utf8_encode ($files[0]));
      echo '<a href="'.$href.'">';
      echo "<img src=images/edit.gif border=0 alt=\"Change .m3u.new\" title=\"Change .m3u.new\" border=0>";
      echo "</a>\n"; 
      echo stripslashes (str_replace (".m3u.new", "", $dir))."<br>\n";
    }
    echo "<br>";
    echo "<a href=import.php?type=$type&checkall=1 onclick=\"setCheckboxes('entriesform', true, 'entries[]'); return false;\">Check All</a> - ";
    echo "<a href=import.php?type=$type onclick=\"setCheckboxes('entriesform', false, 'entries[]'); return false;\">Uncheck All</a><br><br>";
  
    echo "<input type=submit value=\"Import directory\">";
    echo "</FORM>";
  }
  else
  {
    global $NEW_DIR;
    echo "Nothing to import under ".$NEW_DIR;
  }

  echo "<br>";
  echo "</td></tr></table>\n";
  echo "</td></tr></table>\n";

  /* display m3u.new creation bits for each of the dirs without .m3u.new */
  echo "<table cellspacing=2 cellpadding=2 border=0><tr><td valign=top>\n";
  echo "<table cellspacing=3 cellpadding=3 border=0 class=\"searchtable\">\n";
  echo "<tr><td colspan=2 class=menu>";
  echo "<b>These are albums without a corrected .m3u playlist file.<br> ";
  echo "Please create one by clicking the playlist icon before the album path.<br><br></b>";

  if ($dirs_m3u)
  {
    foreach ($dirs_m3u as $i => $dir)
    {
      # FIXME: this doesn't work when not suffixed by '/', why is that ?
      echo '<a href="import.php?dad=create_m3u_new&path='.urlencode ($dir).'/">';
      echo "<img src=images/edit.gif border=0 alt=\"Create corrected playlist\" title=\"Create .m3u.new\" border=0>";
      echo "</a> $dir<br>\n";
    }
    echo "<br>";
    echo "</td></tr></table>\n";
    echo "</td></tr></table>\n";
  }
}

# check the type of import
if ($type)
{
  echo "<table cellspacing=2 cellpadding=2 border=0><tr><td valign=top>\n";
  echo "<table cellspacing=3 cellpadding=3 border=0 class=\"searchtable\">\n";
  echo "<tr><td colspan=2 class=menu>";

  if ($type == 'rescan_files') print "<b>Choose directories to re-import audio from</B><BR>\n";
  if ($type == 'new_albums') print "<b>Choose new albums to import</B><BR>\n";
  if ($type == 'rescan_albums') print "<b>Choose albums to re-import</B><BR>\n";
  if ($type == 'new_files') print "<b>Choose directories to import files & jingles</B><BR>\n";


  /* are we importing new stuff ? */
  if ($type == 'new_albums' || $type == 'new_files')
  {
    $path = $NEW_DIR;
    $dirs = get_directories ($path);
    asort ($dirs);
    //print "<BR>DEBUG: all dirs</BR>\n";
    //print_r ($dirs);

    $dirs_m3u_new = sieve_by_regexp ($dirs, "/\.m3u\.new$/");
    $dirs_m3u = sieve_by_regexp ($dirs, "/\.m3u$/");

    /* now filter out everything we consider to be files */
    $exts = dad_get_audio_extensions ();
    $dirs_files = array ();
    foreach ($exts as $i => $ext)
    {
      $regexp = "/\.".$ext."$/";
      $temp = sieve_by_regexp ($dirs, $regexp);
      $dirs_files = array_merge ($dirs_files, $temp);
    }

    /* everything is prepared, check if we want albums or files */
    if (!isset($_GET['change'])) $change = 0; else $change = 1;
    if ($type == 'new_files')
      import_new_files ($dirs_files, $change);
    else if ($type == 'new_albums')
      import_new_albums ($dirs_m3u_new, $dirs_m3u);

   return 0;
    
  }

  if ($type == 'rescan_albums' || $type == 'rescan_files')
  {
    print "Thomas was lazy, please fix this.\n";
    return 0;
  }

/* all this is old code that needs to be backfolded or removed; it won't
   be executed anymore */
  $path = $AUDIO_DIR;
  if ($type == 'new_albums') $path = $NEW_DIR;
  if ($type == 'new_files') $path = $NEW_DIR;

  if ($path != "/")
  {
    getDirArray($path,0);

    echo "<FORM action=import.php?dad=scan_step1&type=$type method=post name=\"entriesform\">\n";

    if ($type == "new_files")
    {
      $count = count($dirs);
      for ($i=0;$i<$count;$i++)
      {
        echo "<input type=checkbox name=entries[] value=\"".stripslashes($dirs[$i])."\" checked>";
        if ($type != "new_albums") echo stripslashes($dirs[$i])." <br>\n";
      }
      echo "<input type=submit value=\"Import directory\">";
      echo "</form>";
    }
    else
    {
    $count = count($m3u_new);
    for ($i=0;$i<$count;$i++)
    {
      echo "<input type=checkbox name=entries[] value=\"".stripslashes($m3u_new[$i])."\" checked>";
      if ($type != "new_albums") echo stripslashes($m3u_new[$i])."<br>\n";
      else 
      {
        echo "<a href=import.php?dad=create_m3u_new&";
        echo "path=".urlencode (utf8_encode ($m3u_new[$i]))."&m3u=".stripslashes(urlencode (utf8_encode ($m3u_new[$i]))).">";
        echo "<img src=images/edit.gif border=0 alt=\"Change .m3u.new\" title=\"Change .m3u.new\" border=0>";
        echo "</a>\n"; 
        echo stripslashes(str_replace(".m3u.new","",$m3u_new[$i]))."<br>\n";
      }
    }
    echo "<br>";
    if ($count != 0) 
    {
      echo "<a href=import.php?type=$type&checkall=1 onclick=\"setCheckboxes('entriesform', true, 'entries[]'); return false;\">Check All</a> - ";
      echo "<a href=import.php?type=$type onclick=\"setCheckboxes('entriesform', false, 'entries[]'); return false;\">Uncheck All</a><br><br>";
  
      echo "<input type=submit value=\"Import directory\">";
      echo "</form>";
    }
    else echo "Nothing to import";
  }}
  else echo "'$path' is not a good idea !";

  echo "<br>";
  echo "</td></tr></table>\n";
  echo "</td></tr></table>\n";

  if ($type == "new_albums")
  {
    $count_new = count($m3u_no_new);
    //print "DEBUG: count_new: $count_new<BR>\n";
    if ($count_new != 0)
    {
      echo "<table cellspacing=2 cellpadding=2 border=0><tr><td valign=top>\n";
      echo "<table cellspacing=3 cellpadding=3 border=0 class=\"searchtable\">\n";
      echo "<tr><td colspan=2 class=menu>";
      echo "<b>These are albums without a corrected .m3u playlist file.<br> ";
      echo "Please create one by clicking the playlist icon before the album path.<br><br></b>";
      for ($i=0;$i<$count_new;$i++)
      {
        echo "<a href=import.php?dad=create_m3u_new&path=".urlencode (utf8_encode ($m3u_no_new[$i])).">";
        echo "<img src=images/edit.gif border=0 alt=\"Create corrected playlist\" title=\"Create .m3u_new\" border=0>";
        echo "</a> $m3u_no_new[$i]<br>\n";
      }
    }
    echo "<br>";
    echo "</td></tr></table>\n";
    echo "</td></tr></table>\n";
  }
}
?>
