<?php
/* this file does the actual importing and is shown in a refreshing popup
 * window
 * it scans the given tempfile for entries to import
 */

include_once ("functions.inc.php");
header_content_type ();
?>
<html>
<head><title>DAD importer</title>
<meta http-equiv=Content-Type content="text/html; charset=utf-8">
<link href="lib/dad.css" rel="styleSheet" type="text/css">
</head>
<body>
<?php
/* add an error to the error file */
function error_file_add ($errorfile, $error)
{
   if ($error)
   { 
     $fp = fopen ($errorfile, "a");
     fwrite ($fp, "$error\n");
     dad_error ($error);
   }
}
 
/* return the meta tag for refreshing to be used */
function meta_refresh ($tempfile, $errorfile, $line, $type)
{
   $ret =  '<meta http-equiv="Refresh" content="0;';
   $ret .= "url=import.php?dad=scan";
   $ret .= "&tempfile=" . urlencode (addslashes ($tempfile));
   $ret .= "&errorfile=" . urlencode (addslashes ($errorfile));
   $ret .= "&line=$line";
   $ret .= "&type=" .urlencode (addslashes ($type));
   $ret .= '">';
   return $ret;
}

/* start processing */

global $DEBUG;
$type = $_GET['type'];
$tempfile = $_GET['tempfile'];
$errorfile = $_GET['errorfile'];
$line = $_GET['line'];

/* see what entry we're supposed to import using the tempfile */
if (! ($fp = fopen ($tempfile, "r")))
{
  print "<H3>Could not open temporary file $tempfile</H3>";
  return 0;
}
/* seek to the line before the entry we want */
for ($i = 0; $i < $line; ++$i)
{
  $entry = fgets ($fp, 1023);
}
/* try to get it */
$entry = fgets ($fp, 1023);
if (feof ($fp))
{
  /* we were done, so clean up and leave */
  fclose ($fp);
  unlink ($tempfile);
  echo "<H3>Everything is imported.</H3>\n";

  /* check the error file */

  if (is_file ($errorfile))
  {
    $contents = file ($errorfile);
    if ($contents)
    {
      print "List of errors: <BR>\n<PRE>\n";
      foreach ($contents as $line)
        print "$line<BR>\n";
      print "</PRE>\n";
    }
    unlink ($errorfile);
  }
 
  echo "<A href=javascript:window.close();>Close window</a>";
  return;
}

$entry = rtrim ($entry);

/* process the entry */

/* print what we're doing */
print "<H3>";
if      ($type == 'new_albums') echo "Importing new album in '$entry'";
else if ($type == 'new_audio') echo "Importing new audio file '$entry'";
else if ($type == 'rescan_albums') echo "Rescanning album '$entry'";
else if ($type == 'rescan_audio') echo "Rescanning audio '$entry'";
else dad_error ("Did not recognize scan type '$type'");
print "</H3>\n";
flush ();

echo meta_refresh ($tempfile, $errorfile, $line + 1, $type);
 
/* do the actual processing here */
# determine the binary to use
#else if ($type == 'new_audio') $bin = 'dad-import.pl'; # needs moving first
#else if ($type == 'rescan_albums') $bin = 'dad-albumimport.pl';
#else if ($type == 'rescan_audio') $bin = 'dad-import.pl';


if ($type == 'new_albums')
{
  /* just run dad-new-albumimport.pl on it and wait */
  $command = "$SCRIPTS_DIR/dad-new-albumimport.pl \"$entry\"";
  if ($DEBUG)
  {
    echo "<br>DEBUG: would be executing $command<br>\n";
  flush ();
    sleep (5);
  }
  else
  {
    echo "<br>Executing $command";
    flush ();
    exec ("$command", $output, $retval);
    if ($retval)
      error_file_add ($errorfile, "Error on executing $command: return value $retval !");
  }
}

if ($type == 'new_audio')
{
  /* first move the given file to the new location
   * using dad_new_audio_destination ()
   */

  $bin = "$SCRIPTS_DIR/dad-import.pl";

  if (!is_executable ($bin))
    error_file_add ($errorfile, "$bin is not executable !");

  $new = dad_new_audio_destination ($entry);
  if (!$new)
    error_file_add ($errorfile, "Could not create destination for $entry !");

  if (is_file ($new))
    error_file_add ($errorfile, "$new already exists !");

  /* we use a shell move because rename doesn't work across partitions
   * in PHP < 4.3.3 */
  $command = "mv \"$entry\" \"$new\"";
  exec ($command, $output, $retval);
  if ($retval)
    error_file_add ($errorfile, "Error on executing $command: return value $retval !");

  /* now import it */
  $command = "nice $bin \"$new\"";
  exec ($command, $output, $retval);
  if ($retval)
    error_file_add ($errorfile, "Error on executing $command: return value $retval !");
  
 return;
}

  
return;

   
  /* logfile gets set after the first run through this import popup,
   * so if it's not set then this is our first go through */
  if (!isset ($_GET['logfile']))
  {
    /* $_GET is automatically urldecoded and stripslashed */
    $entry = stripslashes (urldecode ($_GET['im']));
    $entry = $_GET['im'];

  }
  else
  {
    /* this is our second run through */

    set_time_limit (0);
    $type = $_GET['type'];

    {
      print "ERROR: type $type not handled !<BR>\n";
      return 0;
    }

    $line = $_GET['line']; /* which line in the file are we at ? */
   $i = 0;
    $imp = '';
    while (!feof($fp1)){
      $dirim = fgets($fp1,100000);
      if ($i == 0) $dir = $dirim;
      if ($i == 1) $imp = $dirim;
     $i++;
    }
    fclose($fp1);
    if ($i < 1 && $im) $imp = $im;
    $dir = trim($dir);
    if ($dir != ''){
      $error = "";
      if ($type != 'album') echo "<h3>Importing ".stripslashes(urldecode($_GET['im']))."</h3>";
      else  echo "<h3>Importing album-name from ".stripslashes(urldecode($_GET['im']))."</h3>";
      if ($type == 'def'){
        exec("find \"".$dir."\" -name *.mp3 -exec ".$SCRIPTS_DIR."/".$bin." {} \;");
        exec("find \"".$dir."\" -name *.ogg -exec ".$SCRIPTS_DIR."/".$bin." {} \;");
      }
      if ($type == 'new') { # new complete album
        $command = $SCRIPTS_DIR."/".$bin." \"".$dir."\"";
        echo "<br>Executing $command";
        exec("$command", $array, $retval);
        if ($retval) $error =  "Error on executing $command: return value $retval !";
      }
     if ($type == 'album') exec("find \"".$dir."\" -exec ".$SCRIPTS_DIR."/".$bin." {} \;");

     $dirf = array();
     $fp = fopen ($file, "r");
     $i = 0;
     while (!feof($fp)) {
       $cont = fgets($fp, 10000);
       array_push($dirf,$cont);
     $i++;
     }
     fclose($fp);
     unlink($file);
     touch($file);
     $fp = fopen($file, "w");
     $a = count($dirf);
     for ($i=1;$i<$a;$i++){
     if ($dirf[$i] != $dir) fwrite($fp,stripslashes($dirf[$i]));
   }
   fclose($fp);
   if ($error)
   { 
     /* add to error file */
     $fp = fopen ($errorfile, "a");
     fwrite ($fp, $error);
     echo "<BR>Error: $error\n";
   }
   else echo "<meta http-equiv=\"Refresh\" content=0;url=import.php?dad=scan&logfile=ok&im=".urlencode(stripslashes($imp))."&type=$type\">";
  }
  else {
    unlink($file);
    if ($type != 'album'){
      echo "<h3>All dirs imported</h3>\n";
      echo "<a href=javascript:window.close();>Close window</a>";
    }
    else{
      echo "<h3>All album-names imported</h3>\n";
      echo "<a href=javascript:window.close();>Close window</a>";
    }
  }
}
?>
</body>
</html>
