<?php
/* 
 * vi:si:et:sw=4:sts=4:ts=4
 *
 * DAD - Digital Audio Database
 *
 * pl_viewpl.inc.php: view a playlist
 *
 *  Copyright (C) 2004 Thomas Vander Stichele
 *  Copyright (C) 2004 Kristof De Jaegher
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Street #330, Boston, MA 02111-1307, USA.
 *
 */

/* show a playlist (temp, last, or saved)
 * GET variables:
 * - type: (temp, last, saved)
 * - playlist_id: optional playlist_id when type is saved
 * - offset: starting offset for position
 * - limit: number of items to display on this page
 */

require_once "DAD/album.php";
require_once "DAD/audio.php";
require_once "DAD/audiofile.php";

$type = $_GET['type'];
if (!isset($_GET['playlist_id']))
    $playlist_id = '';
else 
    $playlist_id = $_GET['playlist_id'];
if (isset($_POST['playlist_id'])) $playlist_id = $_POST['playlist_id'];
if (!isset($_GET['offset'])) $offset = 0; else $offset = $_GET['offset'];
if (!isset($_GET['limit'])) $limit = 20; else $limit = $_GET['limit'];

/* FIXME: what is $id ? */
global $dadid,$id,$lastsid;

$daddb->begin(); 

/* get number of tracks to display on this page;
* starting from $offset, and at most $limit tracks
* as page_count
*/
if ($type == "save" && $playlist_id == 0) $playlist_id = $lastsid;
$query  = "SELECT audio_id, position FROM ".$type."_playlist ";
$query .= "WHERE user_id='$dadid'";
if ($playlist_id) $query .= " AND playlist_id='$playlist_id'";
$query .= " ORDER BY position ASC LIMIT $offset,$limit";
$page_rows = $daddb->all_rows($query);
$page_count = count($page_rows);

/* get total number of tracks in playlist in total_count */
if ($type == "save" && $playlist_id == 0) $playlist_id = $lastsid;
$queryp  = "SELECT audio_id, position FROM ".$type."_playlist ";
$queryp .= "WHERE user_id='$dadid'";
if ($playlist_id) $queryp .= " AND playlist_id='$playlist_id'";
$queryp .= " ORDER BY position ASC";
$daddb->query($queryp);
$total_count = $daddb->row_count();

# if there are more pages, create $more containing HTML code to link
# to all the other pages
/* FIXME: this could be cleaned up a bit */
$more = "<TR>\n<TD>\n&nbsp;";
$setlimit = $limit;
$newoffset = 0;
if ($total_count > $setlimit) {
    $page = 1;
    for ($i = 0; $i < $total_count; $i++) {
        if ($i == $newoffset) {
            if ($offset != $newoffset) {
                $more .= " <A href=playlist.php?dad=playlist";
                $more .= "&type=$type&offset=$newoffset&";
                $more .= "playlist_id=$playlist_id&limit=$limit>";
                $more .= $page;
                $more .= "</A> ";
            } else {
                $more .= " $page ";
            }
            $setlimit = $limit; 
            $page++;
            $newoffset += $limit;
        }
    }
}
$more .= "</TD>";
$more .= "<TD>Limit : <FORM action=playlist.php method=get>\n";
$more .= "<INPUT type=hidden name=dad value=playlist>\n";
$more .= "<INPUT type=hidden name=type value=$type>\n";
$more .= "<INPUT type=hidden name=offset value=0>\n";
$more .= "<INPUT type=hidden name=playlist_id value=$playlist_id>\n";
$more .= "<INPUT type=text name=limit value=\"$limit\" size=3>\n";
$more .= "<INPUT type=submit value=Go>\n";
$more .= "</form></TD>\n";
$more .= "</tr>\n";
?>
<TABLE border=0 cellspacing=0 cellpadding=0 class="menu" width="100%">
  <TR>
    <TD class="menu"><IMG src=images/spacer.gif width=1 height=20></TD>
    <TD nowrap class="menu" align=right><B>Playlists: </B></TD>
    <TD width="100%">&nbsp;   
<?php

echo "<A href=playlist.php>Random songs or album</A> | ";
if ($type == "temp")
    echo "<A href=playlist.php?dad=playlist&type=last>Last playlist</A>";
if ($type == "last")
    echo "<A href=playlist.php?dad=playlist&type=temp>Temporary playlist</A>";
if ($type == "save") {
    echo "<A href=playlist.php?dad=playlist&type=last>Last playlist</A> | ";
    echo "<A href=playlist.php?dad=playlist&type=temp>Temporary playlist</A>";
}
?>
    </TD>
  </TR>
  <TR>
    <TD class="divide" colspan=4>
      <IMG src="images/spacer.gif" width=1 height=1>
    </TD>
  </TR>
</TABLE>

<TABLE cellspacing=2 cellpadding=2 border=0>
  <TR>
    <TD>
      <TABLE cellspacing=3 cellpadding=3 border=0 class="searchtable">
        <TR>
          <TD>
            <B class="menu">Playlist options</B>
            <TABLE>
              <TR>
<?php
$rows = $page_count;
/* if there are items in this playlist, show selection for local/server play */
if ($total_count != 0) {
    echo "<TD>\n";
    echo "<FORM action=playlist.m3u?dad=playsongs&playlist_id=$playlist_id";
    echo " method=post>\n";
    echo "<INPUT type=hidden name=play value=\"$type\">\n";
    echo "<INPUT type=hidden name=dadid value=\"$dadid\">\n";
    echo "Local play<INPUT type=radio name=type value=2 checked>\n";
    echo "Server play<INPUT type=radio name=type value=1>\n";
    echo "<INPUT type=submit value=\"Play\">\n";
    echo "</FORM>\n";
    echo "</TD>\n";
}
/* if there are items in the playlist, and there's no id passed
 * (which means we're not browsing a saved playlist),
 * add an entry box to save this playlist */
if (!$playlist_id && $rows != 0) {
    echo "<TD>\n";
    echo "<FORM onSubmit=\"return checkrequired(this,'Please fill in a playlistname !')\" action=playlist.php?dad=savelist method=post>\n";
    echo "<INPUT type=hidden name=type value=\"$type\">\n";
    echo "<INPUT type=hidden name=dadid value=\"$dadid\">\n";
    echo "<INPUT type=hidden name=id value=\"$id\">\n";
    echo "<INPUT type=text name=requiredplaylistname>\n";
    echo "<INPUT type=submit value=\"Save this playlist\">\n";
    echo "</FORM>\n";
    echo "</TD>\n";
}
/* saved playlist selection drop-down box */
/* FIXME: move this in the "Playlists: menu line just like albums for artist */
echo "<TD>";
echo "<FORM action=playlist.php?dad=playlist&type=save method=post>\n";
echo "<INPUT type=hidden name=type value=save>\n";
echo "<INPUT type=hidden name=dadid value=\"".$dadid."\">\n";
echo "<SELECT name=playlist_id>\n";
echo "<OPTION value=0>Choose playlist\n";
$query  = "SELECT DISTINCT playlist_id,playlistname ";
$query .= "FROM save_playlist ORDER BY playlistname ASC";
$daddb->query($query);
while ($row1 = $daddb->row())
{
    echo "<OPTION value=".$row1->playlist_id;
    if ($row1->playlist_id == $playlist_id) echo " selected";
    echo ">".stripslashes($row1->playlistname);
}
echo "</SELECT>\n";
echo "<INPUT type=submit name=action value=\"Go\">\n";
echo "</FORM>\n";
echo "</TD>\n";

/* playlist copy button */
echo "<TD>";
echo "<FORM onSubmit=\"return checkrequired(this,'Fill in a path!')\"";
echo " action=browse.php?dad=copy method=\"POST\">\n";
echo "<INPUT type=hidden name=play value=\"".$type."\">\n";
echo "<INPUT type=hidden name=dadid value=\"".$dadid."\">\n";
echo "<INPUT type=text size=5 name=requiredpath>\n";
echo "<INPUT type=submit value=\"Copy\">\n";
echo "<INPUT type=hidden name=playlist_id value=\"$playlist_id\">\n";
echo "</FORM>\n";
echo "</TD>\n";

/* playlist delete button */
echo "<TD>";
echo '<A onclick="return confirmdelete()';
echo " href=playlist.php?dad=delete&dadid=$dadid&type=$type";
echo "&playlist_id=$playlist_id>";
echo '<IMG src="images/trashcan_empty.gif "border=0';
echo ' title="Delete this playlist" alt="Delete this playlist">';
echo "</A>\n";
echo "</TD>\n";
?>
              </TR>
            </TABLE>
          </TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
</TABLE>
<IMG src="images/spacer.gif">
<?php
if ($rows == 0) {
    echo "Playlist is empty.\n";
    exit;
}
?>
<TABLE cellspacing=2 cellpadding=2 border=0>
  <TR>
    <TD>
      <TABLE cellspacing=3 cellpadding=3 border=0 class="searchtable">
        <TR>
          <TD>
            <B class=menu>Playlist</B>
            <FORM action=playlist.php?dad=playlistchange method=post>
              <INPUT type=hidden name=dadid value=$dadid>
              <INPUT type=hidden name=type value=$type>
              <INPUT type=hidden name=rows value=$rows>
              <INPUT type=hidden name=playlist_id value=$playlist_id>
              <TABLE cellspacing=0>
                <!-- table header row for playlist items -->
                <TR bgcolor=#CCCCCC>
                  <TD><B>#</B></TD>
                  <TD><B>Song title</B></TD>
                  <TD><B>Artist</B></TD>
                  <TD><B>Album</B></TD>
                  <TD><B>Track</B></TD>
                  <TD><B>Length</B></TD>
                  <TD colspan=2><B>Position</B></TD>
                  <TD><B>Listen</B></TD>
                  <TD colspan=2><B>Delete</B></TD>
                </TR>
<?php

/* display each of the playlist entries */
$totaltime = 0;
for ($i = 0; $i < $page_count; $i++) {
    $position = $page_rows[$i]->position;
    $audio_id = $page_rows[$i]->audio_id;
    $audio = new DAD_audio($audio_id);
    if (isset($album))
	    unset($album);
    if ($audio->row->album_id)
    	$album = new DAD_album($audio->row->album_id);
    $audiofile = new DAD_audiofile($audio->row->audiofile_id);

    /* alternate colors */
    /* FIXME: move color to a config file ? or stylesheet ? */
    $i % 2 ? $color = "#FFFFFF" : $color = "#BBBBBB";
    echo "<TR bgcolor=$color>\n";
    echo "<TD>" . $position . ")</TD>\n";
    echo "<TD>" . $audio->getLink () . "</TD>\n";
    echo "<TD>" . join ($audio->getArtistLinks(), "<BR>\n") . "</TD>\n";
    echo "<TD>" . (isset($album) ? $album->getLink() : "") . "</TD>\n";
    echo "<TD>" . (isset($album) ? $audio->row->track : "") . "</TD>\n";
    $length = $audiofile->row->length;    
    $totaltime += $length;
    echo "<TD>" . hhmmss($length) . "</TD>\n";

    /* display up arrow/link if not the first item in playlist */
    echo "<TD>";
    if ($position != 1) {
        echo "<A href=playlist.php?dad=order&dadid=$dadid";
        echo "&type=$type&action=up&position=$position";
        echo "&audio_id=$audio_id&playlist_id=$playlist_id>";
        echo '<IMG src="images/1uparrow.gif" border=0>';
        echo "</A>"; 
    }
    echo "</TD>\n";

    /* display down arrow/link of not the last item in the playlist */
    echo "<TD>";
    if ($position != $total_count) {
        echo "<A href=playlist.php?dad=order&dadid=$dadid";
        echo "&type=$type&action=dn&position=$position";
        echo "&audio_id=$audio_id&playlist_id=$playlist_id>";
        echo '<IMG src="images/1downarrow.gif" border=0>';
        echo "</A>"; 
    }
    echo "</TD>\n";

    echo "<TD>";
    echo $audio->getPlayLink($dadid, 1, "Stream audio") . "\n";
    echo $audio->getPlayLink($dadid, 2, "Play audio locally") . "\n";
    echo "</TD>\n";
    echo '<TD><A onclick="return confirmdelete()"';
    echo " href=playlist.php?dad=delete&dadid=$dadid&type=$type";
    echo "&position=$position&audio_id$audio_id&rows=$total_count";
    echo "&playlist_id=$playlist_id>";
    echo '<IMG src="images/trashcan_empty.gif" border=0';
    echo ' title="Delete from this playlist"';
    echo ' alt="Delete from this playlist"></A>';
    echo "</TD>\n";
    echo "<TD>";
    echo "<INPUT type=checkbox value=1 checked name=position_$position>";
    echo "</TD>\n";
    echo "</TR>\n";
  }
  /* bottom of playlist */
  $length = $totaltime;
  echo "<TR bgcolor=#CCCCCC><TD colspan=12>This page's total play time: ";
  echo hhmmss($length);
  echo "</TD></TR>";
?>
              </TABLE>
              <INPUT type="submit" value="Change">
            </FORM>
          </TD>
        </TR>
        <TR>
          <TD><?php if (!empty($more)) echo $more; ?></TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
</TABLE>
