<?php

require_once "DAD/audio.php";

/*--------------------------------------------------*/
# ratings_store.inc.php
# stores the ratings given to the audios in the form
/*--------------------------------------------------*/

  $user_id = $_POST['user_id'];
  $catsel = $_POST['catsel'];
  $catent = $_POST['catent'];
  $refresh = $_POST['refresh']; /* URL to refresh to after storing */

  include "functions.inc.php";
  include "ratings.inc.php";

  /* for each song and category
     - if catent- had an entry, then value = entry / 1000.0 (this overrides)
     - if one of the numerical values is chosen then value = value / 1000.0
     - if not applicable, then value = na
     - if unrated, then value = un

     then set the value if it's different from the one in the database */

  $daddb->begin ();

  /* make entries from catent override those in catsel */
  foreach ($catent as $audio_id => $cat_ratings)
  {
    foreach ($cat_ratings as $cat_id => $value)
    {
      if ($catent[$audio_id][$cat_id])
          $catsel[$audio_id][$cat_id] = $catent[$audio_id][$cat_id];
    }
  }

  /* now loop over the values */
  foreach ($catsel as $audio_id => $cat_ratings)
  {
    /* get database ratings */
    $audio = new DAD_audio($audio_id);
    $db_ratings = $audio->getUserRatings($user_id);
    //print "<BR>\nDEBUG: db ratings for audio $audio_id and user $user_id:<BR>\n";
    //print_r($db_ratings);

    foreach ($cat_ratings as $cat_id => $value)
    {
      //print "DEBUG: audio $audio_id, cat $cat_id, value $value<BR>\n";
      /* check what value we should be storing */
      if ($value == "zero") $value = 0;
      /* we need to convert to string because int 0 equals string "na" */
      if (is_numeric ($value)) $value = strval($value / 1000.0);

      /* check the current situation in the database */
      $current = $db_ratings[$cat_id];
      //print "DEBUG: comparing db value $current with post value $value<BR>\n";
      if ($current != $value)
      {
	/* FIXME: find a way to have DEBUG output that says
	 * which audio ratings we are changing */
	//print "audio_set_rating: audio $audio_id, user $user_id, category $cat_id, value $value<BR>\n";
        $audio->setRating($value, $user_id, $cat_id);
      }
    }
  }

  /* finish up */
  header("location: $refresh");
  /* This will print a link in case the location: didn't work */
  print "<A href=\"$refresh\">Click here to continue</A>\n";

?>
